//  flat[i]   minus bias allredy
//  weight=flat_sky
#include <stdio.h>
#define n  4064
char  head[72][80], f1[30];
float a[n][n],ccd[n*48],fm[48], gg,rr,ss;
FILE  *fp,*f[48];			// max file is 48
int   imode,ip=0;

main(ac,av)
int ac; char *av[];                        
{
  int i,j,k;			 
  if(ac<3)stop("\tUsage: superflat batch_file outputfile [mode]\n");

  strcpy(f1,av[1]);		/* batch file */
  fp=fopen(f1,"r");
  if(fp==0){ printf("\n\tbatch_file not found: %s\n",f1); exit(0); }
  for(i=0;i<48;i++){
    fscanf(fp,"%s\n",f1); printf("\n%4d:   %s  ",++ip,f1);
    f[i]=fopen(f1,"rb"); if(f[i]==0){ printf("not found!\n"); exit(0); }
    fread(head,80,72,f[i]);
    sscanf(&head[4][24],"%d",&k);
    if(k!=n){ printf("not a 4064*4064 file\n"); exit(0); }
    k=indexpos(head,"MEANVAL ",72);
    if(k==72){ printf("Do stat4 1st!\n"); exit(0); }
    sscanf(&head[k][20],"%f",&fm[i]);  printf("%9.2f",fm[i]);
    if(feof(fp))break;
  } printf("\n");
  fclose(fp);
  if(ip < 4)stop("too less files\0");
  imode=0;
  if(ac>3){
    strcpy(f1,av[3]);
    if(nindex(f1,"med")==0 || nindex(f1,"MED")==0)imode=1;
  } else if(ip > 9)imode=1;
  if(imode == 1)printf("Median    ");
  if(imode == 0)printf("Mean      ");
  gg=3.9; rr=12.; ss=3.;
 
  work(a);
  strncpy(&head[1][27],"-32",3);	/* real*4 */
  strcpy(f1,av[2]); i=nindex(f1,".");
  if(i>0)strcpy(&f1[i],".fit"); else strcat(f1,".fit");
  k=indexpos(head,"GAIN3   ",72);
  for(i=9;i<80;i++)head[k][i]=32;
  strncpy(&head[k][11],"SUPER FLAT",10);
  if(imode == 1)strncpy(&head[k][21],"_median",7);
  if(imode == 0)strncpy(&head[k][21],"_mean  ",7);
  unlink(f1);
  printf("produce: %s\n",f1);
  fp=fopen(f1,"wb");
  fwrite(head,80,72,fp);
  swap4(a,n*n*4);
  fwrite(a,4,n*n,fp);
  fclose(fp);
}

work(a)
float *a;
{
  float bb[48],w[48];
  float c0,c1,x;
  int i,j,k,l;
  printf("gain= %6.2f   readnoise= %6.2f  nsigma= %6.2f\n",gg,rr,ss);
  for(i=0;i<58;i++)printf("-"); printf("\n");
/*          c0=ss*r/g      c1=ss/sqrt(gW)           */
  c1=0; for(i=0;i<ip;i++)c1+=fm[i]; c1/=ip;
  c0 = ss*rr/gg;
  c1 = ss/sqrt(gg*c1);
  for(i=0;i<n;i++){
    if(i%99==0){ printf("."); fflush(stdout); }
    for(j=0;j<ip;j++){ k=j*n; fread(&ccd[k],4,n,f[j]); }
    swap4(ccd,n*ip*4);		
    for(j=0;j<n;j++){
      l=j; for(k=0;k<ip;k++){ w[k]=fm[k]; bb[k]=ccd[l]/fm[k]; l+=n; }
      if(imode == 0)sup_mean(bb,ip,w,c0,c1,&x);
      if(imode == 1)sup_median(bb,ip,&x);
      if(x < 0.001)x=0.001;
      *a++ =x;
    }
  }
  for(j=0;j<ip;j++)fclose(f[j]); 
}
	
sup_mean(a,nn,w,c0,c1,mean)
float a[],w[],c0,c1,*mean; 
int nn;
{
  int i,j,m;
  float x,xx;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if(a[i]>a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
    x=w[i]; w[i]=w[j]; w[j]=x;
  }
  j=nn;
l10:
  m=j; i=j/2;
  x= (i+i==j) ? (a[i]+a[i-1])*.5 : a[i];
/*   sigma = ((r/g)**2 + <I>/g)** (1/2) */
/*  I[j] - <I> > 3*sigma                 ignore
               > ss*sqrt((r/g)**2+<I>/g)
    I[j] == x[j]*w[j]        w[j] is normalize value, is mean counting 
 so. x[j]w[j] - <xw> > ss*sqrt( 4 + <xw>/g)
                             4 is too small, w use mean value of all w
     x[j]W - <x>W > ss*sqrt(<x>W/g)
     x[j] - <x> > ss/sqrt(gW) * sqrt(<x>)
                > rgs * sqrt(<x>)
   if(<x> < 0) use ss*sqrt((r/g)**2) == ss*r/g
          c0=ss*r/g      c1=ss/sqrt(gW)
*/
  xx = ( x<0.) ? c0 : c1*sqrt(x);
  j=0;
  for(i=0;i<m;i++){
    a[j]=a[i];
    w[j++]=w[i];
    if((a[i]-x) > xx)j--;
  }
  if(m!=j && j>2)goto l10;
/* consider weight  */
  x=xx=0.;
  for(i=0;i<m;i++){ xx+=w[i]; x+=a[i]*w[i]; }
  *mean= x/xx;
}
	
sup_median(a,nn,medi)
float *a,*medi; int nn;
{
  float x; int i,j;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if( *(a+i) > *(a+j)){
    x= *(a+i); *(a+i) = *(a+j); *(a+j)=x;
  }
  i=nn/2;
  *medi = (i+i==nn) ? (*(a+i) + *(a+i-1))*0.5 : *(a+i);
}
